Package com.tietoenator.trip.jxp

# Class TdbControlObject

java.lang.Object
com.tietoenator.trip.jxp.TdbControlObject

All Implemented Interfaces:
  `com.tietoenator.trip.jxp.internal.utils.DOMSink`, `Iterable<String>`

public class TdbControlObject extends Object implements com.tietoenator.trip.jxp.internal.utils.DOMSink, Iterable<String>
This class provides an encapsulation of data related to objects retrieved from the CONTROL database via one of the TdbControlObjectList derivations.

See Also:
  - `TdbControlObjectList`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `TdbControlObject()`
  Constructor, creates a blank object

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `clear()`
  Clear the object's state
  `int`
  `getCategoryId()`
  If this object is a category object, this property will contain the category's unique identifier
  `String`
  `getComment()`
  Get any comment stored with the object
  `String`
  `getCreateDate()`
  Get the date on which the object was first committed to CONTROL.
  `String`
  `getCreateTime()`
  The time on which the first was last committed to CONTROL.
  `String`
  `getCustom(String name)`
  Retrieve the value of the custom key provided
  `String`
  `getDatabase()`
  If this object is a form object (output format, entry form, search form), this method will return the form's associated database name
  `int`
  `getDatabaseRecordCount()`
  If this object is a database, thesaurus or database cluster object, this method will return the number of records in the database, thesaurus or cluster
  `TdbExtendedDatabaseType`
  `getExtendedDatabaseType()`
  When used with a database, thesaurus or cluster object, this method retrieves the extended type of that object.
  `String`
  `getExtendedDatabaseTypeName()`
  Retrieves the name of the extended database type, currently limited to one of USER, SYSTEM, DEMO, or CLASSES
  `int`
  `getManagerRights()`
  If this object is a user object, this method will return the user's management privileges as a bitmask: bit 0 means user management, bit 1 means file management, bit 2 means system
  `String`
  `getModifiedDate()`
  Get the date on which the object was last committed to CONTROL.
  `String`
  `getModifiedTime()`
  Get the time on which the object was last committed to CONTROL.
  `String`
  `getName()`
  Get the name of the object.
  `TdbControlObjectType`
  `getObjectType()`
  Returns the type of this control object.
  `String`
  `getOwnerName()`
  Retrieve the name of the TRIP user that owns this object
  `TdbAccessRights`
  `getReadAccess()`
  If this object is an access rights object, this method will return the read access level, as a value from the TdbAccessRights enumeration.
  `String`
  `getRealName()`
  If this object is a user object, this will return the user's real name
  `int`
  `getSubsystemId()`
  If this object is a classification subsystem object, this method will return the subsystem's unique identifier
  `TdbAccessRights`
  `getWriteAccess()`
  If this object is an access rights object, this method will return the write access level, as a value from the TdbAccessRights enumeration
  `boolean`
  `isAccessRight()`
  Returns a value reflecting whether this object is an access right object
  `boolean`
  `isCategory()`
  Returns a value reflecting whether this object is a category from a classification container object
  `boolean`
  `isClassificationContainer()`
  Returns a value reflecting whether this object is a classification container object
  `boolean`
  `isCluster()`
  Returns a value reflecting whether this object is a database cluster object
  `boolean`
  `isDatabase()`
  Returns a value reflecting whether this object is a database object
  `boolean`
  `isEntryForm()`
  Returns a value reflecting whether this object is a TRIPclassic entry form object
  `boolean`
  `isField()`
  Returns a value reflecting whether this object is a database field object
  `boolean`
  `isFileManager()`
  Returns a value reflecting whether this object is a user object and if that user is an FM
  `boolean`
  `isGridCluster()`
  Returns a value reflecting whether this object is a TRIPgrid cluster object
  `boolean`
  `isGridClusterMember()`
  Returns a value reflecting whether this object is a TRIPgrid cluster member object
  `boolean`
  `isGridHost()`
  Returns a value reflecting whether this object is a TRIPgrid host object
  `boolean`
  `isGridReplicaSet()`
  Returns a value reflecting whether this object is a TRIPgrid replica set object
  `boolean`
  `isGroup()`
  Returns a value reflecting whether this object is a user group object
  `boolean`
  `isManager()`
  Returns a value reflecting whether this object is a user object and if that user is a manager of any type
  `boolean`
  `isOutputFormat()`
  Returns a value reflecting whether this object is an output format object
  `boolean`
  `isProcedure()`
  Returns a value reflecting whether this object is a stored procedure object
  `boolean`
  `isSearchForm()`
  Returns a value reflecting whether this object is a TRIPclassic search form object
  `boolean`
  `isSubsystem()`
  Returns a value reflecting whether this object is a classification subsystem object
  `boolean`
  `isSystemManager()`
  Returns a value reflecting whether this object is a user object and if that user is SYSTEM
  `boolean`
  `isThesaurus()`
  Returns a value reflecting whether this object is a thesaurus object
  `boolean`
  `isUser()`
  Returns a value reflecting whether this object is a user object
  `boolean`
  `isUserManager()`
  Returns a value reflecting whether this object is a user object and if that user is a UM
  `boolean`
  `isXmlEnabled()`
  Returns a value reflecting whether this database is XML enabled.
  `Iterator<String>`
  `iterator()`
  Retrieve an iterator over the custom keys of the object, which may be a zero-size set.
  `void`
  `setComment(String comment)`
  Set a comment to accompany the object
  `void`
  `setDatabase(String name)`
  Set the database with which a form is to be associated; only valid for form types
  `void`
  `setName(String name)`
  Set the name of the object.
  `void`
  `setOwnerName(String owner)`
  Set the name of the TRIP user that owns this object (local only)
  `void`
  `setRealName(String name)`
  If this object is a user object, store the user's real name property

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface java.lang.Iterable

  `forEach, spliterator`

- ## Constructor Details

  - ### TdbControlObject

    public TdbControlObject()
    Constructor, creates a blank object

- ## Method Details

  - ### getName

    public String getName()
    Get the name of the object. The CONTROL field from which this value is extracted varies from object type to object type. For example, for databases and thesauri, the field is D_NAME, whilst for users it is UG_NAME, etc.
    Returns:
      The object's name

  - ### setName

    public void setName(String name)
    Set the name of the object.
    Parameters:
      `name` - The name to be assigned to the object

  - ### getComment

    public String getComment()
    Get any comment stored with the object
    Returns:
      The comment, if any

  - ### setComment

    public void setComment(String comment)
    Set a comment to accompany the object
    Parameters:
      `comment` - The comment

  - ### getModifiedDate

    public String getModifiedDate()
    Get the date on which the object was last committed to CONTROL. The format of this date String will vary depending on the calling user's profile. The value is taken from the field C_MOD_DATE.
    Returns:
      The object's last modification date

  - ### getModifiedTime

    public String getModifiedTime()
    Get the time on which the object was last committed to CONTROL. The value is taken from the field C_MOD_TIME.
    Returns:
      The object's last modification time

  - ### getCreateDate

    public String getCreateDate()
    Get the date on which the object was first committed to CONTROL. The format of this date String will vary depending on the calling user's profile. The value is taken from the field C_CRE_DATE.
    Returns:
      The creation date of the object

  - ### getCreateTime

    public String getCreateTime()
    The time on which the first was last committed to CONTROL. The value is taken from the field C_CRE_TIME.
    Returns:
      The creation time of the object

  - ### getOwnerName

    public String getOwnerName()
    Retrieve the name of the TRIP user that owns this object
    Returns:
      The owning user's name

  - ### setOwnerName

    public void setOwnerName(String owner)
    Set the name of the TRIP user that owns this object (local only)
    Parameters:
      `owner` - The owning user's name

  - ### getExtendedDatabaseType

    public TdbExtendedDatabaseType getExtendedDatabaseType()
    When used with a database, thesaurus or cluster object, this method retrieves the extended type of that object. Note that if the object on which this property is invoked is not a database, thesaurus or cluster, the return will be User type.
    Returns:
      The extended type of the database / thesaurus / cluster

  - ### getExtendedDatabaseTypeName

    public String getExtendedDatabaseTypeName()
    Retrieves the name of the extended database type, currently limited to one of USER, SYSTEM, DEMO, or CLASSES
    Returns:
      The name of the extended type of the database / thesaurus / cluster

  - ### getObjectType

    public TdbControlObjectType getObjectType()
    Returns the type of this control object.
    Returns:
      Enum value representing the control object type.

  - ### isAccessRight

    public boolean isAccessRight()
    Returns a value reflecting whether this object is an access right object
    Returns:
      true if the object is an access right

  - ### isDatabase

    public boolean isDatabase()
    Returns a value reflecting whether this object is a database object
    Returns:
      true if the object is a database object

  - ### isCluster

    public boolean isCluster()
    Returns a value reflecting whether this object is a database cluster object
    Returns:
      true if this object is a cluster object

  - ### isThesaurus

    public boolean isThesaurus()
    Returns a value reflecting whether this object is a thesaurus object
    Returns:
      true if this object is a thesaurus

  - ### isClassificationContainer

    public boolean isClassificationContainer()
    Returns a value reflecting whether this object is a classification container object
    Returns:
      true if the object is a classification container

  - ### isGridCluster

    public boolean isGridCluster()
    Returns a value reflecting whether this object is a TRIPgrid cluster object
    Returns:
      true if this object is a TRIPgrid cluster object

  - ### isGridClusterMember

    public boolean isGridClusterMember()
    Returns a value reflecting whether this object is a TRIPgrid cluster member object
    Returns:
      true if this object is a member of a TRIPgrid cluster

  - ### isGridReplicaSet

    public boolean isGridReplicaSet()
    Returns a value reflecting whether this object is a TRIPgrid replica set object
    Returns:
      true if the object is a TRIPgrid replica set

  - ### isGridHost

    public boolean isGridHost()
    Returns a value reflecting whether this object is a TRIPgrid host object
    Returns:
      true if the object is a TRIPgrid host

  - ### isUser

    public boolean isUser()
    Returns a value reflecting whether this object is a user object
    Returns:
      true if the object is a TRIP user

  - ### isUserManager

    public boolean isUserManager()
    Returns a value reflecting whether this object is a user object and if that user is a UM
    Returns:
      true if the user is a UM

  - ### isFileManager

    public boolean isFileManager()
    Returns a value reflecting whether this object is a user object and if that user is an FM
    Returns:
      true if the user is an FM

  - ### isSystemManager

    public boolean isSystemManager()
    Returns a value reflecting whether this object is a user object and if that user is SYSTEM
    Returns:
      true if the user is SYSTEM

  - ### isManager

    public boolean isManager()
    Returns a value reflecting whether this object is a user object and if that user is a manager of any type
    Returns:
      true if the user is a manager (i.e. either UM or FM)

  - ### isGroup

    public boolean isGroup()
    Returns a value reflecting whether this object is a user group object
    Returns:
      true if the object is a user group

  - ### isProcedure

    public boolean isProcedure()
    Returns a value reflecting whether this object is a stored procedure object
    Returns:
      true if this object is a procedure

  - ### isOutputFormat

    public boolean isOutputFormat()
    Returns a value reflecting whether this object is an output format object
    Returns:
      true if this object is an output format

  - ### isEntryForm

    public boolean isEntryForm()
    Returns a value reflecting whether this object is a TRIPclassic entry form object
    Returns:
      true if this object is a TRIPclassic entry form

  - ### isSearchForm

    public boolean isSearchForm()
    Returns a value reflecting whether this object is a TRIPclassic search form object
    Returns:
      true if this object is a TRIPclassic search form

  - ### isField

    public boolean isField()
    Returns a value reflecting whether this object is a database field object
    Returns:
      true if this object is a database field object

  - ### isSubsystem

    public boolean isSubsystem()
    Returns a value reflecting whether this object is a classification subsystem object
    Returns:
      true if this object is a classification subsystem

  - ### isCategory

    public boolean isCategory()
    Returns a value reflecting whether this object is a category from a classification container object
    Returns:
      true if this object is a category from a classification container

  - ### isXmlEnabled

    public boolean isXmlEnabled()
    Returns a value reflecting whether this database is XML enabled.
    Returns:
      true oif this object is an XML enabled database

  - ### getRealName

    public String getRealName()
    If this object is a user object, this will return the user's real name
    Returns:
      The user's real name

  - ### setRealName

    public void setRealName(String name)
    If this object is a user object, store the user's real name property
    Parameters:
      `name` - The user's real name

  - ### getManagerRights

    public int getManagerRights()
    If this object is a user object, this method will return the user's management privileges as a bitmask: bit 0 means user management, bit 1 means file management, bit 2 means system
    Returns:
      The user's privilege bitmask

  - ### getDatabase

    public String getDatabase()
    If this object is a form object (output format, entry form, search form), this method will return the form's associated database name
    Returns:
      The form's associated database, if any

  - ### setDatabase

    public void setDatabase(String name)
    Set the database with which a form is to be associated; only valid for form types
    Parameters:
      `name` - The name of the database / thesaurus

  - ### getReadAccess

    public TdbAccessRights getReadAccess()
    If this object is an access rights object, this method will return the read access level, as a value from the TdbAccessRights enumeration.
    Returns:
      Read access level

  - ### getWriteAccess

    public TdbAccessRights getWriteAccess()
    If this object is an access rights object, this method will return the write access level, as a value from the TdbAccessRights enumeration
    Returns:
      Write access level

  - ### getSubsystemId

    public int getSubsystemId()
    If this object is a classification subsystem object, this method will return the subsystem's unique identifier
    Returns:
      The subsystem's unique ID

  - ### getCategoryId

    public int getCategoryId()
    If this object is a category object, this property will contain the category's unique identifier
    Returns:
      The category's unique ID

  - ### getDatabaseRecordCount

    public int getDatabaseRecordCount()
    If this object is a database, thesaurus or database cluster object, this method will return the number of records in the database, thesaurus or cluster
    Returns:
      The number of records, or 0 if the object is not of an appropriate type

  - ### getCustom

    public String getCustom(String name)
    Retrieve the value of the custom key provided
    Parameters:
      `name` - Name of the custom key
    Returns:
      Value of the custom key, or a zero length string if not found

  - ### clear

    public void clear()
    Clear the object's state

  - ### iterator

    public Iterator<String> iterator()
    Retrieve an iterator over the custom keys of the object, which may be a zero-size set.
    Specified by:
      `iterator` in interface `Iterable<String>`
    Returns:
      An iterator suitable for use with a "foreach" pattern